require File.expand_path '../../test_helper.rb', __FILE__

require 'crusade/gcm/access_token_fetcher'

require 'fixtures'
require 'webmock/minitest'

describe Crusade::GCM::AccessTokenFetcher do
  let(:described_class) { Crusade::GCM::AccessTokenFetcher }

  describe 'request_token' do
    describe 'successfull' do
      let(:configuration) { Fixtures.default_configuration }
      subject { described_class.new configuration }
      let(:fixture) { Fixtures.access_token 'success' }

      let(:stub) do
        stub_request(:post, "https://accounts.google.com/o/oauth2/token").with({
          headers: { 
            'Content-Type' => 'application/x-www-form-urlencoded'
          },
          params: { "a" => 1 , "b" => "2" }
        }).to_return(status: [ 200, 'ok'], body: fixture.to_json)
      end

      it 'sends a post request to gcm servers' do
        stub

        subject.request_token

        assert_requested stub #check to create spec style assertion
      end

      it 'returns the access token' do
        stub

        token = subject.request_token

        token.must_equal({
          "access_token" => "1/fFBGRNJru1FQd44AzqT3Zg",
          "expires_in" => 3920,
          "token_type" => "Bearer"
        })
      end
    end
  end
end