require File.expand_path '../../test_helper.rb', __FILE__

require 'crusade/gcm/configuration'

describe Crusade::GCM::Configuration do
  let(:described_class) { Crusade::GCM::Configuration }

  describe 'initialize' do
    let(:attributes) do
      {
        client_id: 'client id',
        client_secret: 'client secret',
        refresh_token: 'refresh token',
        token_cache: 'token_cache'
      }
    end

    subject { described_class.new attributes }

    it { subject.client_id.must_equal 'client id' }
    it { subject.client_secret.must_equal 'client secret' }
    it { subject.refresh_token.must_equal 'refresh token' }
    it { subject.token_cache.must_equal 'token_cache' }

    describe 'no attributes' do
      subject { described_class.new }

      it { subject.client_id.must_be_nil }
      it { subject.client_secret.must_be_nil }
      it { subject.refresh_token.must_be_nil }
      it { subject.token_cache.must_equal  Crusade::GCM::InMemoryCache }
    end
  end
end