require File.expand_path '../../test_helper.rb', __FILE__

require 'crusade/gcm/connection'
require 'fixtures'

require 'webmock/minitest'

describe Crusade::GCM::Connection do
  let(:described_class) { Crusade::GCM::Connection }

  describe 'send' do
    describe 'successfull sending' do
      let(:configuration) { Fixtures.default_configuration }
      subject { described_class.new configuration }
      let(:payload) { '{"a": 1, "b" : "2"}' }

      it 'sends a post request to gcm servers' do
        stub = stub_request(:post, "https://www.googleapis.com/gcm_for_chrome/v1/messages").with({
          headers: { 
            'Content-Type' => 'application/json', 
            'Authorization' => 'Bearer ACCESS_TOKEN',
          },
          body: { "a" => 1 , "b" => "2" }
        }).to_return(status: [ 204, 'No Content'])

        subject.send payload, 'ACCESS_TOKEN'

        assert_requested stub #check to create spec style assertion
      end
    end
  end
end